#include "nxm_head.h"
#include "pcap.h"
#include "nxm_defines_v0.6b.h"
#include "nxm_external_v0.6b.h"



extern int decide_service();
extern int curses_fullscreen;

int hash(int,int);
void delete_hash();
void delete_hash1();
void add_hash(char *,int);
int circle_copy(char *,int,char *,short *,short *,int);


int hash(porta,portb)
unsigned short porta;
unsigned short portb;
{
	int result;
	result=((porta&ANDMASK)+(portb&ANDMASK))&ANDMASK;
	return result;
}

/* Stupid, I must write another routine to make almost the same function! */
void delete_hash1()
{
	struct con *cp,*pcp;
	struct con_row *nrl,*prl;
	char buf[256];
	int i,found=0,ii=0;

	for (i=0;i<HASHSIZE;i++)
	{
		cp=con_hash[i];
		pcp=NULL;
		while(cp != NULL)
		{
			if( gtime - cp->last_packet >= 7200)
			{
				sprintf(buf,"Idle con:%-50s",nrl->name);
				set_issyn_label(buf);
				prl=NULL;
				nrl=row_list;
				while(nrl!=NULL)
				{
					if(nrl == cp->pconrow)
                			{
                        			ii=1;
                        			break;
                			}
                			found++;
                			prl=nrl;
                			nrl=nrl->next;
        			}
				if(ii)
				{
					if(xv)
					{
						delete_row(found);
					}else
					{
						curses_delete_row(found);
					}
				}
				nrl=cp->pconrow;
				if(nrl == row_list)
				{
					row_list = nrl->next;
					if(nrl->next != NULL)
						nrl->next->prev = NULL;
					free((char *)nrl);
				} else
				{
					nrl->prev->next = nrl->next;
					if(nrl->next != NULL)
						nrl->next->prev = nrl->prev;
					free((char *)nrl);
				}
				if(cp==current)
				{
					if(xv)
					{
						if(reachedEOF)
						set_status_label("    * EOF *","red");
						else
						set_status_label("    * DEAD *","red");
						select_row(-1);
					}else if(curses_fullscreen)
					{
						write(1, "\n[Connection Terminated]\n", 25);
					}
					current=NULL;
				}else if (cp->plogl != NULL)
				{
					delete_loglog(cp->plogl);
					cp->plogl=NULL;
				}
				if ((cp->curlog==2 || cp->log==2 || cp->log==4) && cp->logfd>0)
				{
					time(&gtime);
					sprintf(buf,"\n*** END AT: %s", ctime(&gtime));
					write(cp->logfd, buf, strlen(buf));
					close(cp->logfd);
				}
				if(pcp)
				{
					pcp->next=cp->next;
					free((char *)cp);
				}else
				{
					con_hash[i]=cp->next;
					free((char *)cp);
				}
			}else
			{
				pcp=cp;
				cp=cp->next;
			}
		}
	}
	return;
}


/* Delete hash from Global TCPhead ,IPhead ,etc */
void delete_hash()
{
	int x;
	struct con *cp,*pcp;
	struct con_row *nrl,*prl;
	char buf[256];
	int found=0,i=0;

	x=hash(TCPhead.source,TCPhead.destination);
	cp=con_hash[x];
	pcp=NULL;
	while(1)
	{
		if(cp==NULL)return;
		if((cp->ips==IPhead.source && cp->ipc==IPhead.destination &&
		cp->ports==TCPhead.source && cp->portc==TCPhead.destination)
		  ||
		(cp->ips==IPhead.destination && cp->ipc==IPhead.source &&
		cp->ports==TCPhead.destination && cp->portc==TCPhead.source))
			break;
		pcp=cp;
		cp=cp->next;
	}

	prl=NULL;
	nrl=row_list;
	while(nrl!=NULL)
	{
		if(nrl == cp->pconrow)
                {
                        i=1;
                        break;
                }
                found++;
                prl=nrl;
                nrl=nrl->next;
        }
	if(i)
	{
		if(xv)
		{
			delete_row(found);
		}else
		{
			curses_delete_row(found);
		}
	}

	nrl=cp->pconrow;
	if(nrl == row_list)
	{
		row_list = nrl->next;
		if(nrl->next != NULL) nrl->next->prev = NULL;
		free((char *)nrl);
	} else
	{
		nrl->prev->next = nrl->next;
		if(nrl->next != NULL) nrl->next->prev = nrl->prev;
		free((char *)nrl);
	}
	if(cp==current)
	{
		if(xv)
		{
			if(reachedEOF)
				set_status_label("    * EOF *","red");
			else
				set_status_label("    * DEAD *","red");
			select_row(-1);
		}
		current=NULL;
	}else if (cp->plogl != NULL)
	{
		delete_loglog(cp->plogl);
		cp->plogl=NULL;
	}
	if ((cp->curlog==2 || cp->log==2 || cp->log==4) && cp->logfd>0)
	{
		time(&gtime);
		sprintf(buf,"\n*** END AT: %s", ctime(&gtime));
		write(cp->logfd, buf, strlen(buf));
		close(cp->logfd);
	}
	if(pcp)
	{
		pcp->next=cp->next;
		free((char *)cp);
	}else
	{
		con_hash[x]=cp->next;
		free((char *)cp);
	}
	return;
}


void add_hash(sp,is_syn)
char *sp;
char is_syn;
{
	char buf[80];
	char service[80];
	struct  con *cp;
	struct con_row  *nrl, *nrlp,*pnrlp;
	int x,row,i;
	char *data;
	struct log_packet lp; /* At present I won't deal with log */
	struct in_addr adr;
	
	/* Since we have choose whether or not call this routine, perhaps
		the following sentence is nouse */
	if(info.DATA_len==0 && is_syn==0)return;

	data=sp+PROTO_HEAD+info.IP_len+info.TCP_len;
	x=hash(TCPhead.source,TCPhead.destination);
	cp=con_hash[x];
	while(cp != NULL)
	{
		cp->last_packet=gtime;
		/* From server to client */
		if(cp->ips==IPhead.source
			&& cp->ipc==IPhead.destination
			&& cp->ports==TCPhead.source
			&& cp->portc==TCPhead.destination)
		{
			if(xv == 2)
			{
				switch(cp->log)
				{
					case -2: /* Not log, not show */
						return;
					case -1: /* show,content when necessary */
						break;
					case  0: /* show,log in csbuf and scbuf */
						circle_copy(data, info.DATA_len,
							cp->scbuf,&cp->scbegin,
							&cp->scend, 2048);
						if (cp->bytes_sent>99999)
							cp->bytes_sent=99999;
						break;
					
					case  1: /* show, log into RAWFILE */
						lp.time=gtime;
						lp.data_len=info.TOTAL_len;
						if(cp->logfd >= 0)
						{
							write(cp->logfd, (char *)&lp,
							sizeof(struct log_packet));
							if (lp.data_len>0)
							write(cp->logfd,sp,lp.data_len);
						}
						break;
					case  2: /* show, log into TEXTFILE */
						if(cp->logfd >= 0)
						write(cp->logfd,data,info.DATA_len);
						break;
					case  3: /* show, log both in buffer and RAWFILE */
						circle_copy(data, info.DATA_len,
							cp->scbuf,&cp->scbegin,
							&cp->scend, 2048);
						if (cp->bytes_sent>99999)
							cp->bytes_sent=99999;

						lp.time=gtime;
						lp.data_len=info.TOTAL_len;
						if(cp->logfd >= 0)
						{
							write(cp->logfd, (char *)&lp,
							sizeof(struct log_packet));
							if (lp.data_len>0)
							write(cp->logfd,sp,lp.data_len);
						}
						break;
					case  4: /* show, log both in buffer and TEXTFILE */
						circle_copy(data, info.DATA_len,
							cp->scbuf,&cp->scbegin,
							&cp->scend, 2048);
						if (cp->bytes_sent>99999)
							cp->bytes_sent=99999;
						if(cp->logfd >= 0)
						write(cp->logfd,data,info.DATA_len);
						break;

					default:
						return;
				}
				if(cp->plogl != NULL)
				{
					/* When this term is killed arbitraly */
					if(write(cp->plogl->ttyfd,data,info.DATA_len) < 0)
					{
						switch (errno)
						{
							case EBADF:
#ifdef DEBUG
 printf("error in write, File descriptor does not exist.");
#endif
								delete_loglog(cp->plogl);
								cp->plogl=NULL;
								break;
							case EIO:
#ifdef DEBUG
 printf("error in write, I/O error.\n");
#endif
								delete_loglog(cp->plogl);
								cp->plogl=NULL;
								break;
							default:
								perror("write");
								break;
						}
					}
				}
			}else 
			{
				/* Perhaps sometime later I will cacel such kind
				 * of stupid thing, It seem to be no much use
				 * if you can not read much of them.SIGN!
				*/
				/*circle_copy(data, info.DATA_len, cp->scbuf,
					&cp->scbegin, &cp->scend, 2048);*/
				cp->bytes_sent+=info.DATA_len;
				if (cp->bytes_sent>99999) cp->bytes_sent=9999;
				switch(cp->curlog)
				{
					case 1:
					{
						/* RAW log */
						struct log_packet lp;
						lp.time=gtime;
						lp.data_len=info.TOTAL_len;
						write(cp->logfd,(char *)&lp,
							sizeof(struct log_packet));
						if (lp.data_len>0)
							write(cp->logfd,sp,
								lp.data_len);
						break;
					}
					case 2:
					{
						if(info.DATA_len > 0)
						write(cp->logfd,data,
							info.DATA_len);
						break;
					}
					default:
						break;
				}
			}
			if(xv == 2) process_input();
			return;
		}else if(cp->ips==IPhead.destination
			&& cp->ipc==IPhead.source
			&& cp->ports==TCPhead.destination 
			&& cp->portc==TCPhead.source)
		{
			if(xv == 2)
			{
				switch(cp->log)
				{
					case -2: /* Not log, not show */
						return;
					case -1: /* show,content when necessary */
						break;
					case  0: /* show,log in csbuf and scbuf */
						circle_copy(data, info.DATA_len,
							cp->csbuf,&cp->csbegin,
							&cp->csend, 80);
						if (cp->bytes_sent>99999)
							cp->bytes_sent=99999;
						break;
					
					case  1: /* show, log into RAWFILE */
						lp.time=gtime;
						lp.data_len=info.TOTAL_len;
						if(cp->logfd >= 0)
						{
							write(cp->logfd, (char *)&lp,
							sizeof(struct log_packet));
							if (lp.data_len>0)
							write(cp->logfd,sp,lp.data_len);
						}
						break;
					case  2: /* show, log into TEXTFILE */
						if(cp->logfd >= 0)
						write(cp->logfd,data,info.DATA_len);
						break;
					case  3: /* show, log both in buffer and RAWFILE */
						circle_copy(data, info.DATA_len,
							cp->csbuf,&cp->csbegin,
							&cp->csend, 80);
						if (cp->bytes_sent>99999)
							cp->bytes_sent=99999;

						lp.time=gtime;
						lp.data_len=info.TOTAL_len;
						if(cp->logfd >= 0)
						{
							write(cp->logfd, (char *)&lp,
							sizeof(struct log_packet));
							if (lp.data_len>0)
							write(cp->logfd,sp,lp.data_len);
						}
						break;
					case  4: /* show, log both in buffer and TEXTFILE */
						circle_copy(data, info.DATA_len,
							cp->csbuf,&cp->csbegin,
							&cp->csend, 80);
						if (cp->bytes_sent>99999)
							cp->bytes_sent=99999;
						if(cp->logfd >= 0)
						write(cp->logfd,data,info.DATA_len);
						break;

					default:
						return;
				}
				if(cp->plogl != NULL && cp->bydirection)
				{
					/* When this term is killed arbitraly */
					if(write(cp->plogl->ttyfd,data,info.DATA_len) < 0)
					{
						switch (errno)
						{
							case EBADF:
#ifdef DEBUG
 printf("error in write, File descriptor does not exist.");
#endif
								delete_loglog(cp->plogl);
								cp->plogl=NULL;
								break;
							case EIO:
#ifdef DEBUG
 printf("error in write, I/O error.\n");
#endif
								delete_loglog(cp->plogl);
								cp->plogl=NULL;
								break;
							default:
								perror("write");
								break;
						}
					}
				}
			}else 
			{
				/* Perhaps sometime later I will cacel such kind
				 * of stupid thing, It seem to be no much use
				 * if you can not read much of them.SIGN!
				*/
				/*circle_copy(data, info.DATA_len, cp->csbuf,
					&cp->csbegin, &cp->csend, 80);*/
				cp->bytes_sent+=info.DATA_len;
				if (cp->bytes_sent>99999) cp->bytes_sent=9999;
				switch(cp->curlog)
				{
					case 1:
					{
						/* RAW log */
						struct log_packet lp;
						lp.time=gtime;
						lp.data_len=info.TOTAL_len;
						write(cp->logfd,(char *)&lp,
							sizeof(struct log_packet));
						if (lp.data_len>0)
							write(cp->logfd,sp,
								lp.data_len);
						break;
					}
					case 2:
					{
						if(info.DATA_len > 0)
						write(cp->logfd,data,
							info.DATA_len);
						break;
					}
					default:
						break;
				}
			}
			if(xv == 2) process_input();
			return;
		}
		if(cp->next == NULL)
		{
			cp->next = (struct con *)malloc(sizeof(struct con));
			cp = cp->next;
			cp->next = NULL;
			break;
		}
		cp=cp->next;
	}
	/* At present I cound not see what its use! */
	if (cp == NULL && is_syn==-1)
	{
		/* This was an ACK only packet for a NEW connection. toss it */
		return;
	}
	/* If con_hash[x] is NULL ,this section is useful */
	if (cp == NULL)
	{
		cp = (struct con *)malloc(sizeof(struct con));
		cp->next = NULL;
		con_hash[x] = cp;
	}
	/* Since we catch the second SYN, then it shoud be server is source,
		client is destination , but if it is a mid-connection, what
		wouuld be judged? Sorry, sniff it , at least present */
	cp->protocol = 0; /* here shoud add to judge protocol and server
				and client. A lot of job, isn't it? */
	if(decide_service(TCPhead.source,TCPhead.destination,service,80))
	{
		cp->ipc=IPhead.source;
		cp->ips=IPhead.destination;
		cp->portc=TCPhead.source;
		cp->ports=TCPhead.destination;
	}else
	{
		cp->ipc=IPhead.destination;
		cp->ips=IPhead.source;
		cp->ports=TCPhead.source;
		cp->portc=TCPhead.destination;
	}

	cp->last_packet = gtime;
	bzero(cp->scbuf,2048);
	bzero(cp->csbuf,80);
	bzero(cp->logfile,60);
	cp->logfd=-1;
	cp->scbegin=0;
	cp->scend=0;
	cp->csbegin=0;
	cp->csend=0;
	cp->bytes_sent=((info.DATA_len>0) ? info.DATA_len:0);
	cp->last_bytes_sent=cp->bytes_sent;
	cp->next=NULL;
	cp->bydirection=1;
	cp->plogl=NULL;

	nrl = (struct con_row *)malloc(sizeof(struct con_row));
	cp->pconrow = nrl;
	adr.s_addr=htonl(cp->ips);
	strncpy(nrl->ipaddress_s,inet_ntoa(adr),50); /* inet_ntoa() perhaps */
	adr.s_addr=htonl(cp->ipc);
	strncpy(nrl->ipaddress_c,inet_ntoa(adr),50); /* inet_ntoa() perhaps */
	sprintf(nrl->name, "%-16s  [%-5d]<->[%5d]  %16s",
			nrl->ipaddress_c,cp->portc,
			cp->ports,nrl->ipaddress_s);
	nrl->changed = 1;
	nrl->pcon = cp;
	nrl->next = NULL;

	/* Perhaps here it is nouse to waste a round up */
	nrlp=row_list;
	pnrlp=NULL;
	row=0;
	while (nrlp != NULL && nrlp->pcon->ports <= cp->ports)
	{
		row++;
		pnrlp=nrlp;
		nrlp=nrlp->next;
	}
	if(row_list==NULL)
	{
		nrl->prev=nrl->next=NULL;
		/*row_list=nrl;*/
	}else if(nrlp==NULL)
	{
		pnrlp->next=nrl;
		nrl->prev=pnrlp;
		nrl->next=NULL;
	}else
	{
		nrl->next=nrlp;
		nrl->prev=pnrlp;
		nrlp->prev=nrl;
		if(pnrlp != NULL)pnrlp->next=nrl;
	}
	if(row == 0) row_list=nrl;
	/*sprintf(buf,"%-50s  %5d",cp->name, cp->bytes_sent);*/
	if(xv)
	{
		/* what is the meaning of (int)cp ? */
		add_row(nrl->name,(int)cp,row);
		if(is_syn)
		{
			sprintf(buf,"New con:%-50s",nrl->name);
			set_issyn_label(buf);
			erase_issyn = (-300);
		}
	}else
	{
		curses_insert_row(nrl->name, cp,row);
	}
	 /* Default is show in rowlist but clicked show content */
	if( xv == 2 )
	{
		cp->log=decide_logstat(cp->ipc,cp->ips,cp->portc,cp->ports);
		if( cp->log > 0 )
		{
			if( cp->log == 1 || cp->log == 3 )
			{
				strftime(cp->logfile,60,"%y%m%d%H%M%S.raw",localtime(&gtime));
				fprintf(logcon,"%s\t%s\n",cp->logfile,nrl->name);
			}
			if( cp->log == 2 || cp->log == 4 )
			{
				strftime(cp->logfile,60,"%y%m%d%H%M%S.txt",localtime(&gtime));
				fprintf(logcon,"%s\t%s\n",cp->logfile,nrl->name);
			}
			if((cp->logfd = open(cp->logfile,O_WRONLY|O_CREAT|O_EXCL,0600)) < 0 )
			{
				perror("open");
				set_error_label("Error in open file");
				return;
			}
		}
	} else
	{
		cp->curlog=decide_logstat(cp->ipc,cp->ips,cp->portc,cp->ports);
		if( cp->curlog > 0 )
		{
			if( cp->curlog == 1 )
			{
				strftime(cp->logfile,60,"%y%m%d%H%M%S.raw",localtime(&gtime));
				fprintf(logcon,"%s\t%s\n",cp->logfile,nrl->name);
			}
			if( cp->curlog == 2 )
			{
				strftime(cp->logfile,60,"%y%m%d%H%M%S.txt",localtime(&gtime));
				fprintf(logcon,"%s\t%s\n",cp->logfile,nrl->name);
			}
			if((cp->logfd = open(cp->logfile,O_WRONLY|O_CREAT|O_EXCL,0600)) < 0 )
			{
				perror("open");
				set_error_label("Error in open file");
				return;
			}
		}
	}
		
#ifdef DEBUG
	fprintf(debug_dev,"Add new con:%s, con_hash[%d]\n", nrl->name,x);
#endif
	return;
}


/* Comfortable ! No need to change ! */
int circle_copy(from, from_len, to, tobegin, toend, length)
char *from, *to;
int from_len, length;
short *tobegin, *toend;
{
	register char *fptr;
	register int  flength, remainder;

	/* STEP 1: Only take the last bufsize bytes of the buffer.
	 *	That's all that will fit into the resultant anyway,
	 *	 so don't bother copying useless data.
	 */
	if (from_len>length)
	{
		fptr=from+(from_len-length);
		flength=length;
	} else
	{
		fptr=from;
		flength=from_len;
	}
	/* STEP 2: Figure out how much to copy and where */
	if ((length-*toend)>flength)
	{
		/* Then we have enough room to simply
		 * "concatenate" the string */
		memcpy(to+*toend, fptr, flength);
		if (*tobegin==(*toend+1)%length)
		{
			/* Then we used to have a full circular buffer.
			 * Continue the trend */
			*toend+=flength;
			*tobegin=((*toend)+1)%length;
		}else 
		/* The begin pointer was still at 0: An un-full buffer.
		 * It's still not full*/
		*toend+=flength;
	}else
	{
		/* Complex situation--Copy to end of buffer,
		 * and reset and copy rest */
		remainder=length-*toend;
		memcpy(to+*toend, fptr, remainder);
		memcpy(to, fptr+(length-*toend), flength-remainder);
		*toend=flength-remainder;
		*tobegin=(*toend+1)%length;
	}
	return(0);
}


void process_input()
{
	int nready;
	struct log_log *plog;
	struct timeval to;
	fd_set fdtemp;
	int c;
	char buf[256];

	plog=loghead;

	to.tv_sec=0;
	to.tv_usec=0;
	rset=allset;
	if((nready=select(maxfd + 1, &rset, NULL, NULL, &to)) < 0)
	{
		perror("select");
		return;
	}
	while(plog != NULL && nready >= 0)
	{
		if(FD_ISSET(plog->ttyfd,&rset))
		{
			read(plog->ttyfd, buf, 1);
			if(*buf=='~')
			{
				write(plog->ttyfd,"[Escape Mode...]", 16);
				to.tv_sec=2;
				to.tv_usec=0;
				FD_ZERO(&fdtemp);
				FD_SET(plog->ttyfd,&fdtemp);
				c=select(255, &fdtemp, 0, 0, &to);
				if (c<0 && errno==EINTR)
				{
					to.tv_sec=1;
					to.tv_usec=0;
					FD_ZERO(&fdtemp);
					FD_SET(plog->ttyfd,&fdtemp);
					c=select(255, &fdtemp, 0, 0, &to);
				}
				if (c>0)
				{
					write(1, "\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b\b \b", 48);
					while ((c=read(plog->ttyfd, buf, 1))<0 && errno==EINTR) ;
					if (c<=0) return;
					switch (*buf)
					{
						case '?':
	sprintf(buf, "\n[  =NetXMon Commands=   ]\n[ ~? Print out this message ]\n[ ~B By/Single directions show ]\n[ ~R Raw log mode ]\n[ ~T Text log mode ]\n[ ~S Stop log  ]\n[ ~E Exit this show ]\n");
							write(plog->ttyfd, buf, strlen(buf));
							break;
						case 'R':
	{
	struct con *pcp;
	char tbuf[50];
	time_t clock;
	pcp=plog->pcon;
	time(&gtime);
	if(pcp->log == 1 || pcp->log == 3)
	{
		write(plog->ttyfd,"Already Logged in raw mode\n",27);
		break;
	}else if(pcp->log == 2 || pcp->log == 4)
	{
		sprintf(tbuf,"\n*** END AT: %s", ctime(&gtime));
		write(pcp->logfd, tbuf, strlen(tbuf));
		close(pcp->logfd);
	}
#ifdef DEBUG
printf("Here in log raw\n");
#endif
	pcp->log=1;
	strftime(pcp->logfile,60,"%y%m%d%H%M%S.raw",localtime(&gtime));
	fprintf(logcon,"%s\t%s\n",pcp->logfile,pcp->pconrow->name);
	if((pcp->logfd = open(pcp->logfile,O_WRONLY|O_CREAT|O_EXCL,0600)) < 0 )
	{
		perror("open");
		set_error_label("Error in open file");
		break;
	}
	}
	break;
						case 'T':
	{
	struct con *pcp;
	char tbuf[50];
	time_t clock;
	pcp=plog->pcon;
	time(&gtime);
	if(pcp->log == 2 || pcp->log == 4)
	{
		write(plog->ttyfd,"Already Logged in text mode\n",27);
		break;
	}else if(pcp->log == 1 || pcp->log == 3)
	{
		close(pcp->logfd);
	}
#ifdef DEBUG
printf("Here in log text\n");
#endif
	pcp->log=2;
	strftime(pcp->logfile,60,"%y%m%d%H%M%S.txt",localtime(&gtime));
	fprintf(logcon,"%s\t%s\n",pcp->logfile,pcp->pconrow->name);
	if((pcp->logfd = open(pcp->logfile,O_WRONLY|O_CREAT|O_EXCL,0600)) < 0 )
	{
		perror("open");
		set_error_label("Error in open file");
		break;
	}
	}
	break;
						case 'S':
	{
	struct con *pcp;
	char tbuf[50];
	pcp=plog->pcon;
	time(&gtime);
	if(pcp->log == -1 || pcp->log == 0)
	{
		write(plog->ttyfd,"Already not in log\n",27);
		break;
	}else if(pcp->log == 2 || pcp->log == 4)
	{
		sprintf(tbuf,"\n*** END AT: %s", ctime(&gtime));
		write(pcp->logfd, tbuf, strlen(tbuf));
	}
	close(pcp->logfd);
#ifdef DEBUG
printf("Here in not log\n");
#endif
	pcp->log=-1;
	}
	break;
						case 'B':
	plog->pcon->bydirection=1-plog->pcon->bydirection;
	break;
						case 'E':
	plog->pcon->plogl=NULL;
	delete_loglog(plog);
	break;
						default:
							write(plog->ttyfd,buf,1);
							break;
					}
				}
			}
			nready--;
		}
		plog=plog->next;
	}
}
